﻿using System.Windows.Forms;
using Shape.Mvp.Commands;
using Shape.Mvp.Sample.Presenters;

namespace Shape.Mvp.Sample
{
   public class ApplicationStartCommandHandler : ICommandHandler<ApplicationStartCommand>
   {
      ExerciseListPresenter _presenter;
      IApplicationController _applicationController;

      public ApplicationStartCommandHandler(ExerciseListPresenter presenter, IApplicationController applicationController)
      {
         _presenter = presenter;
         _applicationController = applicationController;
      }

      public void Execute(ApplicationStartCommand command)
      {
         _presenter.Initialise();

         _applicationController.Show(_presenter.View).AsMainWindow();
      }
   }
}
