﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Shape.Mvp.Commands;
using System.Diagnostics.Contracts;
using Shape.Mvp.Sample.Presenters;

namespace Shape.Mvp.Sample.Commands
{
   public class ShowExerciseDetailsCommandHandler : ICommandHandler<ShowExerciseDetailsCommand>
   {
		private IApplicationController _applicationController;
      private ExerciseDetailPresenter _presenter;

      public ShowExerciseDetailsCommandHandler(
			IApplicationController applicationController,
			ExerciseDetailPresenter presenter)
      {
			Contract.Requires(applicationController != null);
         Contract.Requires(presenter != null);

			_applicationController = applicationController;
         _presenter = presenter;
      }

      public void Execute(ShowExerciseDetailsCommand command)
      {
			_presenter.Initialise(command.Id);

			_applicationController.Show(_presenter.View).AsDialog();
      }
   }
}
