﻿using Shape.Mvp.Presenters;
using Shape.Mvp.Sample.Views;
using Shape.Mvp.Sample.Domain.Repositories;
using System;

namespace Shape.Mvp.Sample.Presenters
{
   public class ExerciseDetailPresenter : Presenter<IExerciseDetailView>
   {
		private IApplicationController _applicationController;
		private IExerciseRepository _exerciseRespository;
		private IExerciseDetailView _view;

      public ExerciseDetailPresenter(
			IApplicationController applicationController,
         IExerciseRepository exerciseRepository,
			IExerciseDetailView view) : base(view) 
		{
			_applicationController = applicationController;
			_exerciseRespository = exerciseRepository;
			_view = view;
		}

		public void Initialise(Guid id)
		{
			var exercise = _exerciseRespository.GetById(id);

			_view.Name = exercise.Name;
		}
   }
}
