﻿using System.Collections.Generic;

namespace Shape.Mvp.Events
{
	public class EventAggregator : IEventAggregator
	{
		private IList<ISubscriber> _subscribers = new List<ISubscriber>();

		public void Subscribe(ISubscriber subscriber)
		{
			_subscribers.Add(subscriber);
		}

		public void Publish<TEvent>(TEvent item)
		{
			// Iterate using index to cater for situation where published event may
			// add additional subscribers
			for (int i = 0; i < _subscribers.Count - 1; i++)
			{
				if (_subscribers[i] is ISubscriber<TEvent>)
				{
					((ISubscriber<TEvent>) _subscribers[i]).Handle(item);
				};
			};
		}
	}
}
