﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Castle.MicroKernel.Registration;
using Shape.Mvp.Events;
using Shape.Mvp.Commands;
using Castle.Windsor;

namespace Shape.Mvp.Ioc.Installers
{
   public class ServicesInstaller : IWindsorInstaller
   {

      public void  Install(Castle.Windsor.IWindsorContainer container, Castle.MicroKernel.SubSystems.Configuration.IConfigurationStore store)
      {
         container.Register(Component.For<IWindsorContainer>().Instance(container));

         container.Register(Classes.FromThisAssembly()
                                   .BasedOn<IApplicationController>()
                                   .WithServiceFromInterface()
                                   .LifestyleSingleton());

         container.Register(Classes.FromThisAssembly()
                                   .BasedOn<IEventAggregator>()
                                   .WithServiceFromInterface()
											  .LifestyleSingleton());

         container.Register(Classes.FromThisAssembly()
                                   .BasedOn<ICommandHandlerFactory>()
                                   .WithServiceFromInterface()
											  .LifestyleSingleton());
      }
   }
}
