﻿using Castle.Windsor;
using Shape.Mvp.Commands;
using System.Diagnostics.Contracts;

namespace Shape.Mvp.Ioc
{
   public class WindsorCommandHandlerFactory : ICommandHandlerFactory
   {
      private IWindsorContainer _container;

      public WindsorCommandHandlerFactory(IWindsorContainer container)
      {
         Contract.Requires(container != null);

         _container = container;
      }

      public ICommandHandler<TCommand> CreateCommandHandler<TCommand>() where TCommand : Command
      {
         return _container.Resolve<ICommandHandler<TCommand>>();
      }
   }
}
