﻿using System.Diagnostics.Contracts;
using Shape.Mvp.Views;

namespace Shape.Mvp.Presenters
{
	public abstract class Presenter<TView> where TView : IView
	{
		private TView _view;

		protected Presenter(TView view)
		{
			Contract.Requires(view != null);

			_view = view;
		}

		public TView View 
		{ 
			get { return _view; } 
		}
	}
}
