﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Shape.Mvp.Views;
using System.Windows.Forms;

namespace Shape.Mvp
{
   public interface IWindowMode
   {
      void AsMainWindow();
      void AsDialog();
      void AsForm();
   }

   internal class WindowManager : IWindowMode
   {
      private Form _currentView;
      private Form _mainWindow;

      public IWindowMode Show(IView view)
      {
         _currentView = view as Form;

			if (_currentView == null)
			{
				throw new InvalidCastException();
			}

         return this;
      }

      void IWindowMode.AsMainWindow()
      {
         _mainWindow = _currentView as Form;

         if (_mainWindow == null)
         {
            throw new InvalidCastException();
         }

         System.Windows.Forms.Application.Run(_currentView as Form);
      }

      void IWindowMode.AsDialog()
      {
         _currentView.ShowDialog(_mainWindow);    
      }

		void IWindowMode.AsForm()
		{
			_currentView.Show(_mainWindow);    
		}
   }
}
